=== debian/changelog ===
tuxpaint (1:0.9.23-1) unstable; urgency=medium

  * New upstream release
  * Update debian-jr uploader e-mail address
    (Closes: #899294)
  * Update standards version to 4.2.1
  * Update copyright years
  * debian/rules: remove build-gnome target, no longer
    exists upstream
  * Add patch to use kbuildsycoca5 instead of kbuildsycoca4
  * Add build-dependency: libkf5service-bin
  * Install .desktop file to /usr/share/applications
  * Remove empty directory usr/share/doc/tuxpaint-data/nn
  * Add lintian-overrides for hardening false-alarms

 -- Jonathan Carter <jcc@debian.org>  Tue, 11 Sep 2018 09:52:01 +0200

tuxpaint (1:0.9.22-12) unstable; urgency=medium

  * Set date in makefile to package date instead of build time
    in attempt to make it reproducible

 -- Jonathan Carter <jcc@debian.org>  Tue, 13 Mar 2018 13:41:07 +0200

tuxpaint (1:0.9.22-11) unstable; urgency=medium

  * Host git repository in salsa.debian.org
  * Update compat level to 11
  * Add Debian Junior team as uploader

 -- Jonathan Carter <jcc@debian.org>  Wed, 14 Feb 2018 12:05:27 +0200

tuxpaint (1:0.9.22-9) unstable; urgency=medium

  * Upload to unstable
  * Update standards version to 4.1.3

 -- Jonathan Carter <jcc@debian.org>  Tue, 13 Feb 2018 09:55:01 +0200

tuxpaint (1:0.9.22-9~exp4) experimental; urgency=medium

  * Add patch to create directory when translations are compiled
    (Closes: #881885)

 -- Jonathan Carter <jcc@debian.org>  Fri, 09 Feb 2018 12:03:40 +0200

tuxpaint (1:0.9.22-9~exp3) experimental; urgency=medium

  * Package rebuild (no changes)

 -- Jonathan Carter <jcc@debian.org>  Wed, 10 Jan 2018 13:31:11 +0200

tuxpaint (1:0.9.22-9~exp2) experimental; urgency=medium

  * Attempt ftbfs fix on x32

 -- Jonathan Carter <jcc@debian.org>  Mon, 20 Nov 2017 12:24:11 +0200

tuxpaint (1:0.9.22-9~exp1) experimental; urgency=medium

  * Attempt ftbfs fix on x32

 -- Jonathan Carter <jcc@debian.org>  Mon, 13 Nov 2017 15:19:02 +0200

tuxpaint (1:0.9.22-8) unstable; urgency=medium

  * Fix copyright section on LGPL-2.1

 -- Jonathan Carter <jcc@debian.org>  Sat, 28 Oct 2017 22:02:09 +0200
