=== debian/changelog ===
tuxpaint (1:0.9.26-1) unstable; urgency=medium

  * Upload to unstable
  * Upgrade to debhelper-compat (=13)
  * Fix odd patches mistakingly introduced in previous upload

 -- Jonathan Carter <jcc@debian.org>  Sun, 05 Sep 2021 21:42:17 +0200

tuxpaint (1:0.9.26-1~exp1) experimental; urgency=medium

  * New upstream release
  * Use imagemagick again instead of graphicsmagick
  * Upgrade to standards version 4.6.0

 -- Jonathan Carter <jcc@debian.org>  Fri, 03 Sep 2021 16:23:33 +0200

tuxpaint (1:0.9.24~git20190922-f7d30d-1~exp2) experimental; urgency=medium

  * No change upload

 -- Jonathan Carter <jcc@debian.org>  Tue, 15 Oct 2019 20:16:32 +0200

tuxpaint (1:0.9.24~git20190922-f7d30d-1~exp1) experimental; urgency=medium

  * New upstream snapshot
  * Update standards version to 4.4.0
  * Upgrade to debhelper-compat (=12)
  * Update copyright years and add debian/*
  * Add librsvg2-bin and imagemagick to build-depends

 -- Jonathan Carter <jcc@debian.org>  Mon, 23 Sep 2019 12:21:18 +0000
