=== debian/control ===
--- 
+++ 
@@ -3,22 +3,25 @@
 Priority: optional
 Maintainer: Jonathan Carter <jcc@debian.org>
 Uploaders: Debian Junior Maintainers <debian-jr@lists.debian.org>
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                gettext,
                gperf,
+	       imagemagick-6.q16,
                libcairo2-dev,
                libfribidi-dev,
                libkf5service-bin,
                libpaper-dev,
                libpng-dev,
                librsvg2-dev,
+	       librsvg2-bin,
                libsdl-image1.2-dev,
                libsdl-mixer1.2-dev (>= 1.2.4-1.1),
                libsdl-pango-dev,
                libsdl-ttf2.0-dev,
                libsdl1.2-dev,
-               libvorbis-dev (>= 1.0.0-2)
-Standards-Version: 4.2.1
+               libvorbis-dev (>= 1.0.0-2),
+	       libimagequant-dev
+Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/debian-jr-team/tuxpaint
 Vcs-Git: https://salsa.debian.org/debian-jr-team/tuxpaint.git
