=== debian/rules ===
--- 
+++ 
@@ -71,7 +71,7 @@
 	# - Note: install-icon is called here even though it seems
 	#   it belongs in tuxpaint-data as it is needed for the menu
 	#   icon.
-	$(MAKE) install-bin install-kde install-icon \
+	$(MAKE) install-bin install-icon \
 	  install-importscript install-default-config install-bash-completion \
 	  PREFIX=$(CURDIR)/debian/tuxpaint/usr \
 	  CONFDIR=$(CURDIR)/debian/tuxpaint/etc/tuxpaint \
@@ -87,7 +87,7 @@
 	  PREFIX=$(CURDIR)/debian/tuxpaint-dev/usr
 
 	# tuxpaint-data:
-	$(MAKE) install-data install-doc install-gettext install-kde-icons \
+	$(MAKE) install-data install-doc install-gettext \
 	  install-example-stamps install-example-starters install-example-templates \
 	  install-im install-osk \
 	  PREFIX=$(CURDIR)/debian/tuxpaint-data/usr \
